function [w,x,train_mod, sig_mod,func_mod,max_amp]= rimi_modulation_func24a(fr,pw,t1,sr1,am1,phasicm,phasicb,phasicl,oww,t2,r,amf,amm,ff,cchoice,funt_choice,KK_yo,max_amp,stepp)

%preallocation
igobb=0;

max_amp1=max_amp;

%--------------------------------------------------------------------------
%normalizing for lazer
if phasicl==1    

    llxl=KK_yo*am1;
    llyl=(113.4-llxl)/25.39;
    llrl=.01;
    llryl=llrl*round(llyl/llrl);
    amp_initial=llryl;
    allxl=max_amp1;
    allyl=(113.4-allxl)/25.39;
    allryl=llrl*round(allyl/llrl);
    max_amp=allryl;
    bllxl=amf;
    bllyl=(113.4-bllxl)/25.39;
    bllryl=llrl*round(bllyl/llrl);
    amf=bllryl;
    cllxl=amm; 
    cllyl=(113.4-cllxl)/25.39; 
    cllryl=llrl*round(cllyl/llrl);
    amm=cllryl;
    
    if isempty(max_amp)|| isempty(stepp) || max_amp==0 || stepp==0  
        max_amp=amp_initial;
        stepp=r;
    end
    
    if max_amp>5
        max_amp=5;
    end
end

igobb=0;

if phasicb==1 || phasicm==1
    amp_initial=KK_yo*am1;
    if isempty(max_amp)|| isempty(stepp) || max_amp==0 || stepp==0  
        max_amp=KK_yo*am1;
        stepp=r;
        igobb=1;
    end
end

%--------------------------------------------------------------------------

am1a= linspace(amp_initial,max_amp,stepp); 

if r>stepp
    am1a(stepp:r)=max_amp;
end

amp1=am1a;
%~~~~~~~~~~~~~~~~~~%~~~~~~~~~~~~~~~~~~%~~~~~~~~~~~~~~~~~~%~~~~~~~~~~~~~~~%

t1=t1/1000;  
pw=pw/1000;  
pww=oww/1000;  

%~~~~~~~~~~~~~~~~~~%~~~~~~~~~~~~~~~~~~%~~~~~~~~~~~~~~~~~~%~~~~~~~~~~~~~~~%
%PULSE CALCULATIONS

T=1/fr;   
tp=round(T*sr1);   
tt=round(t1*sr1);  
tf=round(t2*sr1);   
jj=round(tt/tp)+2;  
pws=pw*sr1;   
l2=round(pww*sr1);        
l4=round(tp-((3*pws)+l2)); 
if l4<1
    l4=0;
end

ttRP_addition=zeros(1,(tf-tt)); 

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%SIGNAL MODULATION ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
pwf=sr1*t1; 
rxx=1:pwf;
time1=rxx/sr1;


if cchoice==1; 
    sig_mod='normal';
    ys=ones(1,pwf);
elseif cchoice==2    
    sig_mod='cosine';
    ys=(amf*cos(4*pi*ff*time1))+amm;
elseif cchoice==3   
    sig_mod='sawtooth';
    ys=(amf*sawtooth(4*pi*ff*time1))+amm;
elseif cchoice==4  
    sig_mod='sine';
    ys=(amf*sin(4*pi*ff*time1))+amm;
elseif cchoice==5    
    sig_mod='square';
    ys=(amf*square(4*pi*ff*time1))+amm;
end


ys(ys<0) = 0;    
 if phasicl==1
     ys(ys>5) = 5;  
 end
 


 %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%PULSE MODULATION ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

t_mod=linspace(1/sr1,pw,pws);

ca=0; 


funt_moo=(ones(1,uint16(pws)));



for moo=1:pws
    if funt_choice==1          
        func_mod='normal';
        funt_moo(moo)=1;         
    elseif funt_choice==2           
        func_mod='linear increase';
        funt_moo(moo)=(t_mod(moo));
    elseif funt_choice==3           
        func_mod='linear decrease';
        funt_moo(moo)=(pw-t_mod(moo));
    elseif funt_choice==4        
        func_mod='exponential increase';
        funt_moo(moo)=(5*(pw-t_mod(moo))/(pw));
    elseif funt_choice==5   
        func_mod='exponential decrease';
        funt_moo(moo)=(5*(t_mod(moo))/(pw));
    elseif funt_choice==6   
        func_mod='gaussian';
        funt_moo(moo)=exp(-1*((((t_mod(moo))-(pw/2))/((2^.5)*(pw/5)))^2));
    elseif funt_choice==7      
        func_mod='sinusoidal';
        funt_moo(moo)=sin((pi*t_mod(moo))/(pw));
    end
end


%~~~~~~~~~~~~~~~~~~~~~~~~~~~~start of the looping~~~~~~~~~~~~~~~~

% preallocation
wax=zeros(stepp,tt);
waxx=zeros(stepp,(tt+(tf-tt)));
w=zeros(r,(tt+(tf-tt)));
ys1=ys;

for sp=1:r;
    if cchoice~=1 && phasicl~=1
        ys(ys>amp1(sp))=amp1(sp);
        ys(ys<0)=0;
    elseif cchoice~=1 && phasicl==1
        ys(ys<amp1(sp))=amp1(sp);
        ys(ys>5)=5;
    elseif cchoice==1
        ys=ys*amp1(sp);
    end

if phasicl==1    
    if funt_choice==1      
        rimiss=funt_moo;  
    elseif funt_choice>=6
        rimiss=1-funt_moo;
    else
        rimiss=1+funt_moo;
    end
    if cchoice~=1 && funt_choice~=1
        rimiss=2-funt_moo;
    end

end


rasa=sum(funt_moo);
samp3=2*pws;
am3=(rasa/samp3);

pw1a=funt_moo;          
pw2=zeros(1,l2);    
pw3=(-1*am3)*(ones(1,2*uint16(pws)));  
pw4=zeros(1,l4);   
[m,n]=size(pw4);

if m==1 && n==0
    pw4=[];
end

%initialization
yys=pws;
tts=tt;

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
if phasicm==1   
    train_mod='Monophasic';

    
    pw5=zeros(1,(tp-pws));
    pw1=pw1a;
    signal=[ pw1 pw5 ];
    
else if phasicb==1   
        train_mod='Biphasic';
        pw1=pw1a;
        signal_1=[ pw1 pw2 pw3 pw4 ];
        signal=signal_1(1:tp);
%         size(signal)

    else if phasicl==1    
            train_mod='Laser';
            pw1=rimiss;   
            pw5=(ones(1,(tp-pws)))*5;
            signal=[ pw5 pw1 ];
            ttRP_addition=5*ones(1,(tf-tt));
        end
    end
end



%~~TRAIN Calculations~~~
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wave=signal;
ttx=1;
pwsg=1;
suum=tp;
ttxx=(suum-pws);

rever_sal=ones(1,pwf);

wavet=wave;
jcm=ys;


for i=1:jj-1
    wavet=[wavet wave];
    if phasicl==1 
    jcm(pwsg:ttxx)=1;
    rever_sal(pwsg:ttxx)=0;
    pwsg=pwsg+suum;
    ttxx=ttxx+suum;
    end
    ys=jcm;
end


if phasicl==1 
     if cchoice==1 && funt_choice~=1  
        gaga=ys.*rever_sal;
        wax(sp,:)=wavet(1:tt)+gaga(1:tt);
        wax(wax>5)=5;
     elseif cchoice~=1 && funt_choice==1 
         wax(sp,:)=wavet(1:tt).*ys(1:tt);
         wax(wax>5)=5;
     elseif cchoice==1 && funt_choice==1 
         wax(sp,:)=wavet(1:tt).*ys(1:tt);
         wax(wax>5)=5;
     elseif cchoice~=1 && funt_choice~=1 
         ppp=1
         wax(sp,:)=wavet(1:tt).*ys(1:tt);
         wax(wax>5)=5;
         wax(wax<amp1(sp))=amp1(sp);
     end
else
    wax(sp,:)=wavet(1:tt).*ys(1:tt);  
end
    

waxx(sp,:)=[wax(sp,:) ttRP_addition]; 
w=waxx;

lwav=length(waxx(sp,:));  

x=linspace(0,t2,lwav);

if igobb==1

    break;   
end

ys=ys1;
end


if igobb==1
    for spx=1:r;
        w(spx,:)=waxx(1,:);
    end
else
    w=waxx;
end

